import 'package:fis_measure/interfaces/date_types/point.dart';

class CardiacCycle {
  // 收缩期起点
  late DPoint systoleStart;
  // 舒张期终点
  late DPoint diastoleEnd;
  // 收缩期峰值
  late DPoint peakSystolic;
  // MD
  late DPoint minimumAbsoluteVelocity;
  late int index;
  // 所在频谱段
  late int regionId;
  // E峰终点
  late DPoint? ePeakEnd;
  // A峰起点
  late DPoint? aPeakStart;
  // E峰
  late DPoint? ePeak;
  // A峰
  late DPoint? aPeak;

  CardiacCycle({
    required this.systoleStart,
    required this.diastoleEnd,
    required this.peakSystolic,
    required this.minimumAbsoluteVelocity,
    required this.index,
    this.regionId = 0,
    this.ePeakEnd,
    this.aPeakStart,
    this.ePeak,
    this.aPeak,
  });
}

/// 最佳心动周期
class BestCardiacCycle {
  // 最佳收缩期起点
  late DPoint bestSystoleStart;
  // 最佳舒张期终点
  late DPoint bestDiastoleEnd;

  BestCardiacCycle({
    required this.bestSystoleStart,
    required this.bestDiastoleEnd,
  });
}
